Leetcode合集】1. 两数之和

1. 两数之和

1. 两数之和

代码仓库地址 : https://github.com/slience-me/Leetcode

个人博客 :https://slienceme.xyz

给定一个整数数组 nums 和一个整数目标值 target,请你在该数组中找出 和为目标值 target 的那 两个 整数,并返回它们的数组下标。

你可以假设每种输入只会对应一个答案。但是,数组中同一个元素在答案里不能重复出现。

你可以按任意顺序返回答案。

示例 1:

复制代码
输入:nums = [2,7,11,15], target = 9
输出:[0,1]
解释:因为 nums[0] + nums[1] == 9 ,返回 [0, 1] 。

示例 2:

复制代码
输入:nums = [3,2,4], target = 6
输出:[1,2]

示例 3:

复制代码
输入:nums = [3,3], target = 6
输出:[0,1]

提示:

  • 2 <= nums.length <= 104
  • -109 <= nums[i] <= 109
  • -109 <= target <= 109
  • 只会存在一个有效答案

方案1:暴力解

cpp 复制代码
class Solution {
public:
    // 1. 暴力解
    vector<int> twoSum(vector<int> &nums, int target) {
        for (int i = 0; i < nums.size(); ++i) {
            for (int j = i + 1; j < nums.size(); ++j) {
                if (nums[i] + nums[j] == target) {
                    return {i, j};
                }
            }
        }
        return {};
    }
};

执行用时分布 8ms 击败92.77%使用 C++ 的用户

消耗内存分布 8.28MB 击败99.93%使用 C++ 的用户

方案2

哈希表初次版本 3次循环

cpp 复制代码
class Solution {
public:
    // 1. 暴力解
    vector<int> twoSum2(vector<int> &nums, int target) {
        // 分析 target=a+b ,
        unordered_map<int, int> myMap;
        for (int i = 0; i < nums.size(); ++i) {
            myMap[nums[i]] = i;
        }
        for (const auto &item: myMap){
            cout<<"key: "<<item.first<<"  value: "<<item.second<<endl;
        }
        for (int i = 0; i < nums.size(); ++i) {
            auto it = myMap.find(target-nums[i]);
            if (it != myMap.end()) {
                int j = it->second;
                if(i==j){ continue;}
                if(i<=j){
                    return {i,j};
                } else{
                    return {j,i};
                }

            };
        }

        return {};
    }
};

执行用时分布 28ms 击败43.57%使用 C++ 的用户

消耗内存分布 11.80MB 击败5.85%使用 C++ 的用户

方案3

单次循环解决问题

cpp 复制代码
class Solution {
public:
    vector<int> twoSum(vector<int> &nums, int target) {
        // 分析 target=a+b ,
        unordered_map<int, int> myMap;
        for (int i = 0; i < nums.size(); ++i) {
            int complement = target - nums[i];
            if (myMap.find(complement) != myMap.end()) {
                return { myMap[complement], i };
            }
            myMap[nums[i]] = i;
        }
        return {};
    }
};

执行用时分布 4ms 击败99.35%使用 C++ 的用户

消耗内存分布 10.79MB 击败21.70%使用 C++ 的用户

相关推荐
dialect_4 小时前
KMP算法
开发语言·c++·算法
reikocao4 小时前
卡尔曼滤波的动态机制:P如何改变融合权重
算法
漂流瓶jz5 小时前
UVA-1612 猜名次 题解答案代码 算法竞赛入门经典第二版
数据结构·算法·题解·排序·aoapc·算法竞赛入门经典
吞下星星的少年·-·5 小时前
Div.2 CF 1130B题(构造,贪心)
算法·贪心·构造
文丑颜不良啊5 小时前
LeetCode1481~1500题目解析
java·leetcode
文丑颜不良啊6 小时前
LeetCode1381~1400题目解析
java·leetcode
是main不是漫6 小时前
【双指针——移动零】数组划分类题目的入门基石
c++·算法
深圳市快瞳科技有限公司7 小时前
野外鸟类AI识别落地实录:输入适配、结构化输出、去重聚合与置信度分流的工程实践
算法·计算机视觉·鸟类识别·鸟类ai识别·野外鸟类观测·林业调查
专注仿真9 小时前
梯度提升类(XFBoost)算法详解与代码实例
开发语言·人工智能·python·算法·大模型训练·控制算法
小豆庄9 小时前
视频遮罩追踪退场后ID撞号的排查—多目标场景下的失效
opencv·算法·bug·视频·python3.11